Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 3211)
@@ -129,5 +129,6 @@
    INTEGER ::   ngrp_znl        ! group ID for the znl processors
    INTEGER ::   ndim_rank_znl   ! number of processors on the same zonal average
-   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_znl  ! dimension ndim_rank_znl, number of the procs into the same znl domain
+   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE ::   nrank_znl  ! dimension ndim_rank_znl, 
+   !                                                        ! number of the procs into the same znl domain
    
    ! North fold condition in mpp_mpi with jpni > 1
@@ -172,4 +173,19 @@
    REAL(wp), DIMENSION(:,:)  , ALLOCATABLE, SAVE    ::   ztab_e, znorthloc_e
    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, SAVE    ::   znorthgloio_e
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+!! These arrays are all private to the module
+!FTRANS t4ns :I :I :z :I :I
+!FTRANS t4sn :I :I :z :I :I
+!FTRANS t4ew :I :I :z :I :I
+!FTRANS t4we :I :I :z :I :I
+!FTRANS t3ns :I :I :z :I
+!FTRANS t3sn :I :I :z :I
+!FTRANS t3ew :I :I :z :I
+!FTRANS t3we :I :I :z :I
+!FTRANS ztab :I :I :z
+!FTRANS znorthloc :I :I :z
+!FTRANS znorthgloio :I :I :z :I
 
    !!----------------------------------------------------------------------
@@ -347,5 +363,5 @@
 
 
-   SUBROUTINE mpp_lnk_3d( ptab, cd_type, psgn, cd_mpp, pval )
+   SUBROUTINE mpp_lnk_3d( ptab3d, cd_type, psgn, cd_mpp, pval )
       !!----------------------------------------------------------------------
       !!                  ***  routine mpp_lnk_3d  ***
@@ -368,5 +384,8 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab     ! 3D array on which the boundary condition is applied
+!FTRANS ptab3d :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab3d   ! 3D array on which the boundary condition is applied
+      REAL(wp),                         INTENT(inout) ::   ptab3d(jpi,jpj,jpk)
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type  ! define the nature of ptab array grid-points
       !                                                             ! = T , U , V , F , W points
@@ -391,15 +410,26 @@
       IF( PRESENT( cd_mpp ) ) THEN      ! only fill added line/raw with existing values
          !
-         ! WARNING ptab is defined only between nld and nle
+         ! WARNING ptab3d is defined only between nld and nle
+#if defined key_z_first
+         DO jj = nlcj+1, jpj                    ! added line(s)   (inner only)
+            DO jk = 1, jpk
+#else
          DO jk = 1, jpk
             DO jj = nlcj+1, jpj                 ! added line(s)   (inner only)
-               ptab(nldi  :nlei  , jj          ,jk) = ptab(nldi:nlei,     nlej,jk)   
-               ptab(1     :nldi-1, jj          ,jk) = ptab(nldi     ,     nlej,jk)
-               ptab(nlei+1:nlci  , jj          ,jk) = ptab(     nlei,     nlej,jk)
+#endif
+               ptab3d(nldi  :nlei  , jj          ,jk) = ptab3d(nldi:nlei,     nlej,jk)   
+               ptab3d(1     :nldi-1, jj          ,jk) = ptab3d(nldi     ,     nlej,jk)
+               ptab3d(nlei+1:nlci  , jj          ,jk) = ptab3d(     nlei,     nlej,jk)
             END DO
+#if defined key_z_first
+         END DO
+         DO ji = nlci+1, jpi                    ! added column(s) (full)
+            DO jk = 1, jpk
+#else
             DO ji = nlci+1, jpi                 ! added column(s) (full)
-               ptab(ji           ,nldj  :nlej  ,jk) = ptab(     nlei,nldj:nlej,jk)
-               ptab(ji           ,1     :nldj-1,jk) = ptab(     nlei,nldj     ,jk)
-               ptab(ji           ,nlej+1:jpj   ,jk) = ptab(     nlei,     nlej,jk)
+#endif
+               ptab3d(ji           ,nldj  :nlej  ,jk) = ptab3d(     nlei,nldj:nlej,jk)
+               ptab3d(ji           ,1     :nldj-1,jk) = ptab3d(     nlei,nldj     ,jk)
+               ptab3d(ji           ,nlej+1:jpj   ,jk) = ptab3d(     nlei,     nlej,jk)
             END DO
          END DO
@@ -410,13 +440,13 @@
          !                                        !* Cyclic east-west
          IF( nbondi == 2 .AND. (nperio == 1 .OR. nperio == 4 .OR. nperio == 6) ) THEN
-            ptab( 1 ,:,:) = ptab(jpim1,:,:)
-            ptab(jpi,:,:) = ptab(  2  ,:,:)
+            ptab3d( 1 ,:,:) = ptab3d(jpim1,:,:)
+            ptab3d(jpi,:,:) = ptab3d(  2  ,:,:)
          ELSE                                     !* closed
-            IF( .NOT. cd_type == 'F' )   ptab(     1       :jpreci,:,:) = zland    ! south except F-point
-                                         ptab(nlci-jpreci+1:jpi   ,:,:) = zland    ! north
+            IF( .NOT. cd_type == 'F' )   ptab3d(     1       :jpreci,:,:) = zland    ! south except F-point
+                                         ptab3d(nlci-jpreci+1:jpi   ,:,:) = zland    ! north
          ENDIF
          !                                   ! North-South boundaries (always closed)
-         IF( .NOT. cd_type == 'F' )   ptab(:,     1       :jprecj,:) = zland       ! south except F-point
-                                      ptab(:,nlcj-jprecj+1:jpj   ,:) = zland       ! north
+         IF( .NOT. cd_type == 'F' )   ptab3d(:,     1       :jprecj,:) = zland       ! south except F-point
+                                      ptab3d(:,nlcj-jprecj+1:jpj   ,:) = zland       ! north
          !
       ENDIF
@@ -430,6 +460,6 @@
          iihom = nlci-nreci
          DO jl = 1, jpreci
-            t3ew(:,jl,:,1) = ptab(jpreci+jl,:,:)
-            t3we(:,jl,:,1) = ptab(iihom +jl,:,:)
+            t3ew(:,jl,:,1) = ptab3d(jpreci+jl,:,:)
+            t3we(:,jl,:,1) = ptab3d(iihom +jl,:,:)
          END DO
       END SELECT  
@@ -462,14 +492,14 @@
       CASE ( -1 )
          DO jl = 1, jpreci
-            ptab(iihom+jl,:,:) = t3ew(:,jl,:,2)
+            ptab3d(iihom+jl,:,:) = t3ew(:,jl,:,2)
          END DO
       CASE ( 0 ) 
          DO jl = 1, jpreci
-            ptab(jl      ,:,:) = t3we(:,jl,:,2)
-            ptab(iihom+jl,:,:) = t3ew(:,jl,:,2)
+            ptab3d(jl      ,:,:) = t3we(:,jl,:,2)
+            ptab3d(iihom+jl,:,:) = t3ew(:,jl,:,2)
          END DO
       CASE ( 1 )
          DO jl = 1, jpreci
-            ptab(jl      ,:,:) = t3we(:,jl,:,2)
+            ptab3d(jl      ,:,:) = t3we(:,jl,:,2)
          END DO
       END SELECT
@@ -483,6 +513,6 @@
          ijhom = nlcj-nrecj
          DO jl = 1, jprecj
-            t3sn(:,jl,:,1) = ptab(:,ijhom +jl,:)
-            t3ns(:,jl,:,1) = ptab(:,jprecj+jl,:)
+            t3sn(:,jl,:,1) = ptab3d(:,ijhom +jl,:)
+            t3ns(:,jl,:,1) = ptab3d(:,jprecj+jl,:)
          END DO
       ENDIF
@@ -515,14 +545,14 @@
       CASE ( -1 )
          DO jl = 1, jprecj
-            ptab(:,ijhom+jl,:) = t3ns(:,jl,:,2)
+            ptab3d(:,ijhom+jl,:) = t3ns(:,jl,:,2)
          END DO
       CASE ( 0 ) 
          DO jl = 1, jprecj
-            ptab(:,jl      ,:) = t3sn(:,jl,:,2)
-            ptab(:,ijhom+jl,:) = t3ns(:,jl,:,2)
+            ptab3d(:,jl      ,:) = t3sn(:,jl,:,2)
+            ptab3d(:,ijhom+jl,:) = t3ns(:,jl,:,2)
          END DO
       CASE ( 1 )
          DO jl = 1, jprecj
-            ptab(:,jl,:) = t3sn(:,jl,:,2)
+            ptab3d(:,jl,:) = t3sn(:,jl,:,2)
          END DO
       END SELECT
@@ -535,6 +565,6 @@
          !
          SELECT CASE ( jpni )
-         CASE ( 1 )     ;   CALL lbc_nfd      ( ptab, cd_type, psgn )   ! only 1 northern proc, no mpp
-         CASE DEFAULT   ;   CALL mpp_lbc_north( ptab, cd_type, psgn )   ! for all northern procs.
+         CASE ( 1 )     ;   CALL lbc_nfd      ( ptab3d, cd_type, psgn )   ! only 1 northern proc, no mpp
+         CASE DEFAULT   ;   CALL mpp_lbc_north( ptab3d, cd_type, psgn )   ! for all northern procs.
          END SELECT
          !
@@ -742,5 +772,5 @@
       !!                  ***  routine mpp_lnk_3d_gather  ***
       !!
-      !! ** Purpose :   Message passing manadgement for two 3D arrays
+      !! ** Purpose :   Message passing management for two 3D arrays
       !!
       !! ** Method  :   Use mppsend and mpprecv function for passing mask 
@@ -759,6 +789,11 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab1     ! first and second 3D array on which 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab2     ! the boundary condition is applied
+!FTRANS ptab1 :I :I :z
+!FTRANS ptab2 :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab1     ! first and second 3D array on which 
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   ptab2     ! the boundary condition is applied
+      REAL(wp),                         INTENT(inout) ::   ptab1(jpi,jpj,jpk)
+      REAL(wp),                         INTENT(inout) ::   ptab2(jpi,jpj,jpk)
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type1  ! nature of ptab1 and ptab2 arrays 
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type2  ! i.e. grid-points = T , U , V , F or W points
@@ -1113,5 +1148,5 @@
       !!                  ***  routine mppsend  ***
       !!                   
-      !! ** Purpose :   Send messag passing array
+      !! ** Purpose :   Send message passing array
       !!
       !!----------------------------------------------------------------------
@@ -1575,5 +1610,5 @@
 
 
-   SUBROUTINE mpp_minloc3d( ptab, pmask, pmin, ki, kj ,kk)
+   SUBROUTINE mpp_minloc3d( ptab3d, pmask3d, pmin, ki, kj ,kk)
       !!------------------------------------------------------------------------
       !!             ***  routine mpp_minloc  ***
@@ -1585,6 +1620,11 @@
       !!
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab         ! Local 2D array
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask        ! Local mask
+!FTRANS ptab3d  :I :I :z
+!FTRANS pmask3d :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab3d       ! Local 3D array
+!     REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask3d      ! Local mask
+      REAL(wp), INTENT(in   )                          ::   ptab3d(jpi,jpj,jpk)
+      REAL(wp), INTENT(in   )                          ::   pmask3d(jpi,jpj,jpk)
       REAL(wp)                         , INTENT(  out) ::   pmin         ! Global minimum of ptab
       INTEGER                          , INTENT(  out) ::   ki, kj, kk   ! index of minimum in global frame
@@ -1596,10 +1636,17 @@
       !!-----------------------------------------------------------------------
       !
-      zmin  = MINVAL( ptab(:,:,:) , mask= pmask == 1.e0 )
-      ilocs = MINLOC( ptab(:,:,:) , mask= pmask == 1.e0 )
-      !
+      zmin  = MINVAL( ptab3d(:,:,:) , mask= pmask3d == 1.e0 )
+      ilocs = MINLOC( ptab3d(:,:,:) , mask= pmask3d == 1.e0 )
+      !
+!! DCSE_NEMO: Attention! 
+#if defined key_z_first
+      ki = ilocs(2) + nimpp - 1
+      kj = ilocs(3) + njmpp - 1
+      kk = ilocs(1)
+#else
       ki = ilocs(1) + nimpp - 1
       kj = ilocs(2) + njmpp - 1
       kk = ilocs(3)
+#endif
       !
       zain(1,:)=zmin
@@ -1655,5 +1702,5 @@
 
 
-   SUBROUTINE mpp_maxloc3d( ptab, pmask, pmax, ki, kj, kk )
+   SUBROUTINE mpp_maxloc3d( ptab3d, pmask3d, pmax, ki, kj, kk )
       !!------------------------------------------------------------------------
       !!             ***  routine mpp_maxloc  ***
@@ -1665,6 +1712,11 @@
       !!
       !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab         ! Local 2D array
-      REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask        ! Local mask
+!FTRANS ptab3d  :I :I :z
+!FTRANS pmask3d :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   ptab3d       ! Local 2D array
+!     REAL(wp), DIMENSION (jpi,jpj,jpk), INTENT(in   ) ::   pmask3d      ! Local mask
+      REAL(wp), INTENT(in   )                          ::   ptab3d(jpi,jpj,jpk)       ! Local 2D array
+      REAL(wp), INTENT(in   )                          ::   pmask3d(jpi,jpj,jpk)      ! Local mask
       REAL(wp)                         , INTENT(  out) ::   pmax         ! Global maximum of ptab
       INTEGER                          , INTENT(  out) ::   ki, kj, kk   ! index of maximum in global frame
@@ -1676,10 +1728,17 @@
       !!-----------------------------------------------------------------------
       !
-      zmax  = MAXVAL( ptab(:,:,:) , mask= pmask == 1.e0 )
-      ilocs = MAXLOC( ptab(:,:,:) , mask= pmask == 1.e0 )
-      !
+      zmax  = MAXVAL( ptab3d(:,:,:) , mask= pmask3d == 1.e0 )
+      ilocs = MAXLOC( ptab3d(:,:,:) , mask= pmask3d == 1.e0 )
+      !
+!! DCSE_NEMO: Attention!
+#if defined key_z_first
+      ki = ilocs(2) + nimpp - 1
+      kj = ilocs(3) + njmpp - 1
+      kk = ilocs(1)
+#else
       ki = ilocs(1) + nimpp - 1
       kj = ilocs(2) + njmpp - 1
       kk = ilocs(3)
+#endif
       !
       zain(1,:)=zmax
@@ -1731,5 +1790,5 @@
       !!                  ***  routine mppobc  ***
       !! 
-      !! ** Purpose :   Message passing manadgement for open boundary
+      !! ** Purpose :   Message passing management for open boundary
       !!     conditions array
       !!
@@ -1748,5 +1807,7 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   ztab => wrk_2d_1
+!! DCSE_NEMO: Warning! ztab is also a lib_mpp module variable
+!     USE wrk_nemo, ONLY:   ztab => wrk_2d_1
+      USE wrk_nemo, ONLY:   ztab2d => wrk_2d_1
       !
       INTEGER , INTENT(in   )                     ::   kd1, kd2   ! starting and ending indices
@@ -1775,5 +1836,5 @@
       ! boundary condition initialization
       ! ---------------------------------
-      ztab(:,:) = 0.e0
+      ztab2d(:,:) = 0.e0
       !
       IF( ktype==1 ) THEN                                  ! north/south boundaries
@@ -1805,5 +1866,5 @@
             DO jj = ijpt0, ijpt1
                DO ji = iipt0, iipt1
-                  ztab(ji,jj) = ptab(ji,jk)
+                  ztab2d(ji,jj) = ptab(ji,jk)
                END DO
             END DO
@@ -1811,5 +1872,5 @@
             DO jj = ijpt0, ijpt1
                DO ji = iipt0, iipt1
-                  ztab(ji,jj) = ptab(jj,jk)
+                  ztab2d(ji,jj) = ptab(jj,jk)
                END DO
             END DO
@@ -1823,6 +1884,6 @@
             iihom = nlci-nreci
             DO jl = 1, jpreci
-               t2ew(:,jl,1) = ztab(jpreci+jl,:)
-               t2we(:,jl,1) = ztab(iihom +jl,:)
+               t2ew(:,jl,1) = ztab2d(jpreci+jl,:)
+               t2we(:,jl,1) = ztab2d(iihom +jl,:)
             END DO
          ENDIF
@@ -1853,10 +1914,10 @@
          IF( nbondi == 0 .OR. nbondi == 1 ) THEN
             DO jl = 1, jpreci
-               ztab(jl,:) = t2we(:,jl,2)
+               ztab2d(jl,:) = t2we(:,jl,2)
             END DO
          ENDIF
          IF( nbondi == -1 .OR. nbondi == 0 ) THEN
             DO jl = 1, jpreci
-               ztab(iihom+jl,:) = t2ew(:,jl,2)
+               ztab2d(iihom+jl,:) = t2ew(:,jl,2)
             END DO
          ENDIF
@@ -1869,6 +1930,6 @@
             ijhom = nlcj-nrecj
             DO jl = 1, jprecj
-               t2sn(:,jl,1) = ztab(:,ijhom +jl)
-               t2ns(:,jl,1) = ztab(:,jprecj+jl)
+               t2sn(:,jl,1) = ztab2d(:,ijhom +jl)
+               t2ns(:,jl,1) = ztab2d(:,jprecj+jl)
             END DO
          ENDIF
@@ -1898,10 +1959,10 @@
          IF( nbondj == 0 .OR. nbondj == 1 ) THEN
             DO jl = 1, jprecj
-               ztab(:,jl) = t2sn(:,jl,2)
+               ztab2d(:,jl) = t2sn(:,jl,2)
             END DO
          ENDIF
          IF( nbondj == 0 .OR. nbondj == -1 ) THEN
             DO jl = 1, jprecj
-               ztab(:,ijhom+jl) = t2ns(:,jl,2)
+               ztab2d(:,ijhom+jl) = t2ns(:,jl,2)
             END DO
          ENDIF
@@ -1909,5 +1970,5 @@
             DO jj = ijpt0, ijpt1            ! north/south boundaries
                DO ji = iipt0,ilpt1
-                  ptab(ji,jk) = ztab(ji,jj)  
+                  ptab(ji,jk) = ztab2d(ji,jj)  
                END DO
             END DO
@@ -1915,5 +1976,5 @@
             DO jj = ijpt0, ilpt1            ! east/west boundaries
                DO ji = iipt0,iipt1
-                  ptab(jj,jk) = ztab(ji,jj) 
+                  ptab(jj,jk) = ztab2d(ji,jj) 
                END DO
             END DO
@@ -2201,5 +2262,8 @@
       !!
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pt3d      ! 3D array on which the b.c. is applied
+!FTRANS pt3d :I :I :z
+!! DCSE_NEMO: work around a deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pt3d      ! 3D array on which the b.c. is applied
+      REAL(wp),                         INTENT(inout) ::   pt3d(jpi,jpj,jpk)
       CHARACTER(len=1)                , INTENT(in   ) ::   cd_type   ! nature of pt3d grid-points
       !                                                              !   = T ,  U , V , F or W  gridpoints
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 3211)
@@ -22,4 +22,7 @@
    PUBLIC mpp_init       ! called by opa.F90
    PUBLIC mpp_init2      ! called by opa.F90
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -142,5 +145,5 @@
       !  Computation of local domain sizes ilcit() ilcjt()
       !  These dimensions depend on global sizes jpni,jpnj and jpiglo,jpjglo
-      !  The subdomains are squares leeser than or equal to the global
+      !  The subdomains are squares lesser than or equal to the global
       !  dimensions divided by the number of processors minus the overlap
       !  array (cf. par_oce.F90).
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 3211)
@@ -32,4 +32,10 @@
      MODULE PROCEDURE ldf_zpf_1d, ldf_zpf_1d_3d, ldf_zpf_3d
   END INTERFACE
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
 
    !! * Substitutions
@@ -207,4 +213,5 @@
       REAL(wp), INTENT(in   )                         ::   pbot       ! bottom value (0<pbot<= 1)
       REAL(wp), INTENT(in   ), DIMENSION          (:) ::   pdep       ! depth of the gridpoint (T, U, V, F)
+!FTRANS pah :I :I :z
       REAL(wp), INTENT(inout), DIMENSION      (:,:,:) ::   pah        ! adimensional vertical profile
       !!
@@ -248,4 +255,5 @@
       REAL(wp), INTENT(in   )                         ::   pwam       ! width of inflection
       REAL(wp), INTENT(in   )                         ::   pbot       ! bottom value (0<pbot<= 1)
+!FTRANS pdep pah :I :I :z
       REAL(wp), INTENT(in   ), DIMENSION      (:,:,:) ::   pdep       ! dep of the gridpoint (T, U, V, F)
       REAL(wp), INTENT(inout), DIMENSION      (:,:,:) ::   pah        ! adimensional vertical profile
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce.F90	(revision 3211)
@@ -35,4 +35,7 @@
 #endif
 
+   !! * Control permutation of array indices
+#  include "ldfdyn_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_oce_ftrans.h90	(revision 3211)
@@ -0,0 +1,22 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  ldfdyn_oce_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   ldfdyn_oce.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+#if defined key_dynldf_c3d
+!FTRANS ahm1 ahm2 ahm3 ahm4 :I :I :z
+#endif
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_substitute.h90	(revision 3211)
@@ -20,4 +20,5 @@
 #    define   fsahmu(i,j,k)    ahm3(i,j,k)
 #    define   fsahmv(i,j,k)    ahm4(i,j,k)
+#    include "ldfdyn_oce_ftrans.h90"
 #elif defined key_dynldf_c2d
 !   ' key_dynldf_c2d' :                 2D coefficient
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 3211)
@@ -31,4 +31,11 @@
    PUBLIC   ldf_eiv    ! routine called by step.F90
    
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -84,6 +91,6 @@
       ! ----------------------------------------
       IF( ln_traldf_grif ) THEN
-         DO jk = 1, jpk
 #  if defined key_vectopt_loop  
+         DO jk = 1, jpk
 !CDIR NOVERRCHK 
             DO ji = 1, jpij   ! vector opt.
@@ -100,8 +107,16 @@
                zhw(ji,1) = zhw(ji,1) + ze3w
             END DO
+         END DO
 #  else
+#     if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpk
+#     else
+         DO jk = 1, jpk
             DO jj = 2, jpjm1
 !CDIR NOVERRCHK 
                DO ji = 2, jpim1
+#     endif
                   ! Take the max of N^2 and zero then take the vertical sum 
                   ! of the square root of the resulting N^2 ( required to compute 
@@ -117,9 +132,9 @@
                END DO
             END DO
+         END DO
 #  endif
-         END DO
       ELSE
-         DO jk = 1, jpk
 #  if defined key_vectopt_loop  
+         DO jk = 1, jpk
 !CDIR NOVERRCHK 
             DO ji = 1, jpij   ! vector opt.
@@ -137,8 +152,16 @@
                zhw(ji,1) = zhw(ji,1) + ze3w
             END DO
+         END DO
 #  else
+#     if defined key_z_first
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               DO jk = 1, jpk
+#     else
+         DO jk = 1, jpk
             DO jj = 2, jpjm1
 !CDIR NOVERRCHK 
                DO ji = 2, jpim1
+#     endif
                   ! Take the max of N^2 and zero then take the vertical sum 
                   ! of the square root of the resulting N^2 ( required to compute 
@@ -155,6 +178,6 @@
                END DO
             END DO
+         END DO
 #  endif
-         END DO
       END IF
 
